package org.gcube.data.access.storagehub;

import javax.inject.Singleton;
import org.gcube.common.authorization.library.provider.AuthorizationProvider;
import org.gcube.common.storagehub.model.Paths;
import org.gcube.common.storagehub.model.Path;

@Singleton
public class PathUtil {
	
	public  Path getWorkspacePath(String login){
		return Paths.getPath(String.format("/Home/%s/%s",login,Constants.WORKSPACE_ROOT_FOLDER_NAME));
	}

	public Path getHome(String login){
		return Paths.getPath(String.format("/Home/%s",login));
	}

	@Deprecated
	public  Path getOldTrashPath(String login){
		return Paths.append(getWorkspacePath(login),Constants.TRASH_ROOT_FOLDER_NAME);
	}
	
	public  Path getTrashPath(String login){
		return Paths.append(getHome(login), Constants.TRASH_ROOT_FOLDER_NAME);
	}
	
	@Deprecated
	public  Path getOldVREsPath(String login){
		return Paths.append(getWorkspacePath(login),Constants.OLD_VRE_FOLDER_PARENT_NAME);
	}
	
	public  Path getVREsPath(String login){
		return Paths.append(getWorkspacePath(login),Constants.PERSONAL_VRES_FOLDER_PARENT_NAME);
	}
	
	public  Path getSharedWithMePath(String login){
		return Paths.append(getWorkspacePath(login),Constants.SHARED_WITH_ME_PARENT_NAME);
	}
	
		
}
